package com.huimv.eartag2.config;

import com.huimv.eartag2.common.mq.Const;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.core.TopicExchange;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Configuration
public class TopicRabbitMQConfig {
    //原始数据队列
    @Bean
    public Queue askDeviceQueue() {
        return new Queue(Const.QUEUE_ASK_DEVICE);
    }
    @Bean
    public Queue askEartagQueue() {
        return new Queue(Const.QUEUE_ASK_EARTAG);
    }

    //原始交换机
    @Bean
    TopicExchange askDeviceExchange() {
        return new TopicExchange(Const.EXCHANGE_ASK_DEVICE);
    }
    @Bean
    TopicExchange askEartagExchange() {
        return new TopicExchange(Const.EXCHANGE_ASK_EARTAG);
    }

    //绑定关系
    @Bean
    Binding bindingDeviceExchangeMessage() {
        return BindingBuilder.bind(askDeviceQueue()).to(askDeviceExchange()).with(Const.ROUTING_KEY_ASK_DEVICE);
    }
    @Bean
    Binding bindingEartagExchangeMessage() {
        return BindingBuilder.bind(askEartagQueue()).to(askEartagExchange()).with(Const.ROUTING_KEY_ASK_EARTAG);
    }

//    //采集器注册队列路由键
//    public final static String deviceRegister = "topic.device.register";
//    //采集器在线记录队列路由键
//    public final static String deviceOnline = "topic.device.online";
//    //采集器总状态队列路由键
//    public final static String deviceAllState = "topic.device.allstate";
//    //采集器温度路由键
//    public final static String deviceTemp = "topic.device.temp";
//    //采集器心跳路由键
//    public final static String deviceHeartbeat = "topic.device.heartbeat";
//    //采集器原始数据
//    public final static String deviceRawData = "topic.device.rawdata";
//    //耳标原始数据
//    public final static String eartagRawData = "topic.eartag.rawdata";
    //

//    //采集器注册队列
//    @Bean
//    public Queue deviceQueue() {
//        return new Queue(deviceRegister);
//    }
//    //采集器在线记录队列
//    @Bean
//    public Queue deviceOnlineQueue() {
//        return new Queue(deviceOnline);
//    }
//    //采集器总状态队列
//    @Bean
//    public Queue deviceAllStateQueue() {
//        return new Queue(deviceAllState);
//    }

//    //设备交换机
//    @Bean
//    TopicExchange deviceExchange() {
//        return new TopicExchange("deviceTopicExchange");
//    }
//    //耳标交换机
//    @Bean
//    TopicExchange eartagExchange() {
//        return new TopicExchange("eartagTopicExchange");
//    }


}
