package com.huimv.eartag2.process2.controller;

import com.huimv.eartag2.common.utils.BizConst;
import com.huimv.eartag2.common.utils.MathUtil;
import com.huimv.eartag2.process2.service.ICacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.TimeUnit;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@RestController
@RequestMapping("/redis")
public class RedisContrller {
    @Resource
    private RedisTemplate redisTemplate;
    @Autowired
    private ICacheService cacheService;

    @RequestMapping(value = "/get1",method = RequestMethod.GET)
    public void get1(@RequestParam(value = "farmId",required = true) String farmId) {
        //
        Integer deviceTotal = cacheService.getDeviceTotal(farmId);
        System.out.println("## deviceTotal>>"+deviceTotal);
    }


    @RequestMapping(value = "/set",method = RequestMethod.GET)
    public void set1(@RequestParam(value = "name",required = true) String name,String company){
        if(name == null || name == ""){
            name="java";
        }
        String setKey = "testSet";
        redisTemplate.opsForSet().add(setKey, name);

        setKey = "set:online:device:101:2022-03-14";
        Set<String> resultSet = redisTemplate.opsForSet().members(setKey);
        System.out.println(setKey+" >>"+resultSet+", "+resultSet.size());
        boolean memberStatus = redisTemplate.opsForSet().isMember(setKey,company);
        System.out.println("memberStatus>>"+memberStatus);
//        redisTemplate.expire(setKey,2, TimeUnit.HOURS);
        redisTemplate.expire(setKey,2, TimeUnit.MINUTES);
        //根据key获取过期时间
        System.out.println("过期时间>>"+redisTemplate.getExpire(setKey));

        setKey = "farm_earmark_online_101_2022-03-02";
        Set<String> resultSet2 = redisTemplate.opsForSet().members(setKey);
        System.out.println(setKey+" members >>"+resultSet2);

        setKey = "farm_earmark_online_101_2022-03-02";
        boolean memberStatus2 = redisTemplate.opsForSet().isMember(setKey,company);
        System.out.println(setKey+" isMember >>"+memberStatus2);

        String hashKey = BizConst.FARM_ALL_STATUS_PREFIX+"101";
        System.out.println("hashKey>>>>>>>>>>>>>>>>>>>>>>>>"+hashKey);
        Map allMap = redisTemplate.opsForHash().entries(hashKey);
        System.out.println("allMap>>>>>>>>>>>>>>>>>>>>>>>>>"+allMap.toString());
        if(allMap.size()==0){
            System.out.println("==0");
        }else{
            System.out.println("!=0");
        }
    }

    @RequestMapping(value = "/getSetSize",method = RequestMethod.GET)
    public void getSetSize(){
        String setKey = "set:online:device:101:2022-03-14";
        Set<String> resultSet = redisTemplate.opsForSet().members(setKey);
        System.out.println(setKey+" >>"+resultSet);
        System.out.println(setKey+" 数量 >>"+resultSet.size());
    }

    @RequestMapping(value = "/countRate",method = RequestMethod.GET)
    public void countRate(){
        String temp = "2328";
//        BigDecimal deviceRateBd= new BigDecimal(temp).divide(new BigDecimal(100),2,BigDecimal.ROUND_HALF_UP);
        BigDecimal deviceRateBd = MathUtil.countEnvtemp(temp,2);

        System.out.println("deviceRateBd 333 >>"+deviceRateBd);
    }

    @RequestMapping(value = "/getRegisterByFarmId",method = RequestMethod.GET)
    public void getRegisterByFarmId(@RequestParam(value = "deviceCode",required = true) String deviceCode){
        //202007239999869
        Map<Object, Object> map = cacheService.getDeviceRegister(deviceCode);
        System.out.println("map >>"+map.toString());

        String deviceAlias = (String)cacheService.getDeviceRegisterProperty(deviceCode,"deviceAlias");
        System.out.println("deviceAlias>>"+deviceAlias);
    }
}
