package com.huimv.eartag2.process2.service;

import com.huimv.eartag2.common.dao.entity.*;

import java.text.ParseException;
import java.util.Map;

public interface ICacheService {
    //证是否存在当天总状态数据
    Boolean isExistTodayFarmAllStatus(String deviceCode) throws ParseException;

    //
    Object getFarmIdByDeviceCode(String deviceCode);

    //
    Object getCreateDateByFarmId(String farmId);

    //
    void putFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity) throws ParseException;

    //
    void putAllFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity) throws ParseException;

    //
    void flashAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity);

    //判断是否在线状态
    boolean isExistDeviceOnlineSet(String farmId, String deviceCode, String todayDateText);

    //将deviceCode加入到在线缓存当中
    void putDeviceToOnline(String farmId, String deviceCode, String todayDateText);

    //
    void putDeviceRegister(String deviceCode, EartagDeviceRegisterEntity deviceRegisterEntity);

    //将设备数据保存到在线数据中
    void putDeviceInOnline(String deviceOnlineHashKey, EartagDeviceOnlineEntity eartagDeviceOnlineEntity);

    //
    boolean isExistEartagOnlineSet(String farmId, String earmark, String todayDateText);


    void putEartagToOnlineInSet(String farmId, String earmark, String todayDateText) throws ParseException;

    //从缓存读取在线耳标数量
    void getEartagOnlineTotalFromCache(String farmId, String todayDateText);

    //更新耳标注册消息缓存
    void putEartagRegister(String earmark, EartagEartagRegisterEntity eartagRegisterEntity);

    //更新耳标在线统计
    void putEartagOnlineCount(String earmark, EartagEartagOnlineEntity eartagOnlineEntity);

    //
    Integer getDeviceTotal(String farmId);

    //读取全部注册信息
    Map<Object, Object> getDeviceRegister(String farmId);

    //读取属性
    Object getDeviceRegisterProperty(String deviceCode, String deviceAlias);
}
