package com.huimv.eartag2.process2.service;

import java.sql.Date;
import java.sql.Timestamp;
import java.text.ParseException;
import java.util.Map;

public interface IDeviceService {
    // 保存在线数据
    void saveDeviceOnline(Map deviceMap);

    //保存状态数据
    void saveDeviceStatus(Map deviceMap);

    //更新设备注册数据
    void updateDeviceRegister(String deviceCode);

    //更新设备在线数据
    void updateDeviceOnline(String deviceCode) throws ParseException;

    //处理状态数据
    void updateFarmDeviceStatus(String deviceCode) throws ParseException;

    //
    String getFarmIdByDeviceCode(String deviceCode);

    //更新设备注册信息
    void updateDeviceRegister(String farmId, String deviceCode, Timestamp nowTimestamp);

    //更新设备在线信息
    void updateDeviceOnlineCount(String farmId, String deviceCode, String todayDateText, Timestamp nowTimestamp, Date todayDate) throws ParseException;

    //更新设备总状态信息
    void updateDeviceAllStatus(String farmId, String deviceCode, String todayDateText, Timestamp nowTimestamp, Date todayDate) throws ParseException;

    //更新设备在线表中的环境温度参数
    void updateDeviceOnlineWithEnvtemp(String farmId, String deviceCode) throws ParseException;

    //更新总状态中的环境温度
    void updateEnvtempOfDeviceAllStatus(String farmId, String deviceCode) throws ParseException;
}
